<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'DatabaseUpdateException' => '\\StructType\\DatabaseUpdateException',
            'DuplicateExtensionException' => '\\StructType\\DuplicateExtensionException',
            'InvalidCredentialsException' => '\\StructType\\InvalidCredentialsException',
            'InvalidDataException' => '\\StructType\\InvalidDataException',
            'NoSuchContextException' => '\\StructType\\NoSuchContextException',
            'NoSuchFilestoreException' => '\\StructType\\NoSuchFilestoreException',
            'NoSuchUserException' => '\\StructType\\NoSuchUserException',
            'RemoteException' => '\\StructType\\RemoteException',
            'StorageException' => '\\StructType\\StorageException',
            'change' => '\\StructType\\Change',
            'changeByModuleAccess' => '\\StructType\\ChangeByModuleAccess',
            'changeByModuleAccessName' => '\\StructType\\ChangeByModuleAccessName',
            'changeCapabilities' => '\\StructType\\ChangeCapabilities',
            'changeMailAddressPersonal' => '\\StructType\\ChangeMailAddressPersonal',
            'changeModuleAccessGlobal' => '\\StructType\\ChangeModuleAccessGlobal',
            'create' => '\\StructType\\Create',
            'createByModuleAccess' => '\\StructType\\CreateByModuleAccess',
            'createByModuleAccessName' => '\\StructType\\CreateByModuleAccessName',
            'createByModuleAccessNameResponse' => '\\StructType\\CreateByModuleAccessNameResponse',
            'createByModuleAccessResponse' => '\\StructType\\CreateByModuleAccessResponse',
            'createResponse' => '\\StructType\\CreateResponse',
            'delete' => '\\StructType\\Delete',
            'deleteMultiple' => '\\StructType\\DeleteMultiple',
            'exists' => '\\StructType\\Exists',
            'existsResponse' => '\\StructType\\ExistsResponse',
            'getAccessCombinationName' => '\\StructType\\GetAccessCombinationName',
            'getAccessCombinationNameResponse' => '\\StructType\\GetAccessCombinationNameResponse',
            'getContextAdmin' => '\\StructType\\GetContextAdmin',
            'getContextAdminResponse' => '\\StructType\\GetContextAdminResponse',
            'getData' => '\\StructType\\GetData',
            'getDataResponse' => '\\StructType\\GetDataResponse',
            'getModuleAccess' => '\\StructType\\GetModuleAccess',
            'getModuleAccessResponse' => '\\StructType\\GetModuleAccessResponse',
            'getMultipleData' => '\\StructType\\GetMultipleData',
            'getMultipleDataResponse' => '\\StructType\\GetMultipleDataResponse',
            'getUserCapabilities' => '\\StructType\\GetUserCapabilities',
            'list' => '\\StructType\\_list',
            'listAll' => '\\StructType\\ListAll',
            'listAllResponse' => '\\StructType\\ListAllResponse',
            'listByAliasDomain' => '\\StructType\\ListByAliasDomain',
            'listByAliasDomainResponse' => '\\StructType\\ListByAliasDomainResponse',
            'listCaseInsensitive' => '\\StructType\\ListCaseInsensitive',
            'listCaseInsensitiveResponse' => '\\StructType\\ListCaseInsensitiveResponse',
            'listResponse' => '\\StructType\\ListResponse',
            'moveFromContextToUserFilestore' => '\\StructType\\MoveFromContextToUserFilestore',
            'moveFromMasterToUserFilestore' => '\\StructType\\MoveFromMasterToUserFilestore',
            'moveFromUserFilestoreToMaster' => '\\StructType\\MoveFromUserFilestoreToMaster',
            'moveFromUserToContextFilestore' => '\\StructType\\MoveFromUserToContextFilestore',
            'moveUserFilestore' => '\\StructType\\MoveUserFilestore',
            'Exception' => '\\StructType\\Exception',
            'getUserCapabilitiesResponse' => '\\StructType\\GetUserCapabilitiesResponse',
            'moveFromUserToContextFilestoreResponse' => '\\StructType\\MoveFromUserToContextFilestoreResponse',
            'moveFromMasterToUserFilestoreResponse' => '\\StructType\\MoveFromMasterToUserFilestoreResponse',
            'moveUserFilestoreResponse' => '\\StructType\\MoveUserFilestoreResponse',
            'moveFromContextToUserFilestoreResponse' => '\\StructType\\MoveFromContextToUserFilestoreResponse',
            'moveFromUserFilestoreToMasterResponse' => '\\StructType\\MoveFromUserFilestoreToMasterResponse',
            'IOException' => '\\StructType\\IOException',
            'UserModuleAccess' => '\\StructType\\UserModuleAccess',
            'Context' => '\\StructType\\Context',
            'Database' => '\\StructType\\Database',
            'SOAPStringMapMap' => '\\StructType\\SOAPStringMapMap',
            'SOAPMapEntry' => '\\StructType\\SOAPMapEntry',
            'SOAPStringMap' => '\\StructType\\SOAPStringMap',
            'Entry' => '\\StructType\\Entry',
            'User' => '\\StructType\\User',
            'Group' => '\\StructType\\Group',
            'Filestore' => '\\StructType\\Filestore',
            'Credentials' => '\\StructType\\Credentials',
        );
    }
}
