<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for moveFromContextToUserFilestore StructType
 * @subpackage Structs
 */
class MoveFromContextToUserFilestore extends AbstractStructBase
{
    /**
     * The ctx
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Context
     */
    public $ctx;
    /**
     * The user
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\User
     */
    public $user;
    /**
     * The dst_filestore_id
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \StructType\Filestore
     */
    public $dst_filestore_id;
    /**
     * The max_quota
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $max_quota;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * Constructor method for moveFromContextToUserFilestore
     * @uses MoveFromContextToUserFilestore::setCtx()
     * @uses MoveFromContextToUserFilestore::setUser()
     * @uses MoveFromContextToUserFilestore::setDst_filestore_id()
     * @uses MoveFromContextToUserFilestore::setMax_quota()
     * @uses MoveFromContextToUserFilestore::setAuth()
     * @param \StructType\Context $ctx
     * @param \StructType\User $user
     * @param \StructType\Filestore $dst_filestore_id
     * @param int $max_quota
     * @param \StructType\Credentials $auth
     */
    public function __construct(\StructType\Context $ctx = null, \StructType\User $user = null, \StructType\Filestore $dst_filestore_id = null, $max_quota = null, \StructType\Credentials $auth = null)
    {
        $this
            ->setCtx($ctx)
            ->setUser($user)
            ->setDst_filestore_id($dst_filestore_id)
            ->setMax_quota($max_quota)
            ->setAuth($auth);
    }
    /**
     * Get ctx value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Context|null
     */
    public function getCtx()
    {
        return isset($this->ctx) ? $this->ctx : null;
    }
    /**
     * Set ctx value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Context $ctx
     * @return \StructType\MoveFromContextToUserFilestore
     */
    public function setCtx(\StructType\Context $ctx = null)
    {
        if (is_null($ctx) || (is_array($ctx) && empty($ctx))) {
            unset($this->ctx);
        } else {
            $this->ctx = $ctx;
        }
        return $this;
    }
    /**
     * Get user value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\User|null
     */
    public function getUser()
    {
        return isset($this->user) ? $this->user : null;
    }
    /**
     * Set user value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\User $user
     * @return \StructType\MoveFromContextToUserFilestore
     */
    public function setUser(\StructType\User $user = null)
    {
        if (is_null($user) || (is_array($user) && empty($user))) {
            unset($this->user);
        } else {
            $this->user = $user;
        }
        return $this;
    }
    /**
     * Get dst_filestore_id value
     * @return \StructType\Filestore|null
     */
    public function getDst_filestore_id()
    {
        return $this->dst_filestore_id;
    }
    /**
     * Set dst_filestore_id value
     * @param \StructType\Filestore $dst_filestore_id
     * @return \StructType\MoveFromContextToUserFilestore
     */
    public function setDst_filestore_id(\StructType\Filestore $dst_filestore_id = null)
    {
        $this->dst_filestore_id = $dst_filestore_id;
        return $this;
    }
    /**
     * Get max_quota value
     * @return int|null
     */
    public function getMax_quota()
    {
        return $this->max_quota;
    }
    /**
     * Set max_quota value
     * @param int $max_quota
     * @return \StructType\MoveFromContextToUserFilestore
     */
    public function setMax_quota($max_quota = null)
    {
        // validation for constraint: int
        if (!is_null($max_quota) && !is_numeric($max_quota)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($max_quota)), __LINE__);
        }
        $this->max_quota = $max_quota;
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\MoveFromContextToUserFilestore
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MoveFromContextToUserFilestore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
